#include <inttypes.h>
#include <math.h>
#include <stdio.h>

typedef struct {
  char c;
} CharStruct;

typedef struct {
  double d;
} DoubleStruct;

typedef struct {
  uint64_t a;
  int b;
  int c;
} LargeStruct;

static void PrintCharStruct(CharStruct cs) {
  printf("CharStruct contains '%c'\n", cs.c);
}

static void PrintDoubleStruct(DoubleStruct ds) {
  printf("DoubleStruct contains %f\n", ds.d);
}

static void PrintLargeStruct(LargeStruct ls) {
  printf("LargeStruct contains %" PRIu64 ", %d, %d\n",
         ls.a, ls.b, ls.c);
}

int main(int argc, char* argv[]) {
  CharStruct cs;
  cs.c = 'a';
  PrintCharStruct(cs);

  DoubleStruct ds;
  ds.d = M_PI;
  PrintDoubleStruct(ds);

  LargeStruct ls;
  ls.a = (uint64_t) -1;
  ls.b = 10;
  ls.c = 255;
  PrintLargeStruct(ls);

  return 0;
}
